/*
 * Copyright 2021-2022 Xilinx, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef OSLAYER_H__
#define OSLAYER_H__

#include <sys/types.h>
#include <stdint.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <errno.h>
#include <stdarg.h>
#include <stdbool.h>
#include <stddef.h>
#include <stdio.h>

#ifdef __linux__

#include <sys/stat.h>
#include <sys/mman.h>
#include <unistd.h>
#include <endian.h>
#include <fcntl.h>
#include <getopt.h>
#include <sched.h>
#define _GNU_SOURCE
#include <pthread.h>
#include <syslog.h>

#ifdef DO_TRACE
#define SYSPRINT    printf
#endif

#else /* agent (bare metal) either a72 or r5 */

#define htole32(x)	(x)
#define le32toh(x)	(x)

#ifdef DO_TRACE
#include "xil_printf.h"
#define SYSPRINT    xil_printf
#endif

#endif  /* __linux__ */

#ifdef DO_TRACE
#define TRACE()                 SYSPRINT("%s: %d\n\r",__func__,__LINE__)
#define TRACE_PRINT             SYSPRINT
#define TRACE_DECL(x,y)         x y
#define TRACE_ASSIGN(x,y)       x=(y)
#else
#define TRACE()
extern void no_trace(void);
#define TRACE_PRINT(str,...)    no_trace()
#define TRACE_DECL(x,y)
#define TRACE_ASSIGN(x,y)
#endif  /* DO_TRACE */

/*
 * Useful placeholder in for loops to indicate that a term is empty
 */
#define NOTHING

#endif  /* OSLAYER_H__ */
