/*
 * Copyright 2021-2022 Xilinx, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include "prog_app.h"

void InitSys(Sys* pSys)
{
    TRACE();
    agentInitPEFH(&pSys->tPEFContext);
    TRACE();
    InitMultibootState(&pSys->tMultibootState);
    TRACE();
}

int main(void)
{
    Sys tSys;
    ProgEnvFuncs* pPEF;
    MultibootState* pMS;
    static uint32_t q;

    WAIT_FOR_PLM_DONE();

    GrabSysMutex();
        TRACE_PRINT("%04x: Build info: %s %s\n\r",SYS_MUTEX_MASTER_ID,__DATE__,__TIME__);
    ReleaseSysMutex();

    TRACE();
    InitSys(&tSys);
    TRACE();

    pPEF = &tSys.tPEFContext.tPEF;
    pMS = &tSys.tMultibootState;
    for(q = 0;;q++) {
        SenseMultibootInputs(pMS);

        if(PCIE_STATE_UP == pMS->ePcieState) {
            if(0 == (q & 0xffffff)) {
                TRACE();
            }
            StepPEF(pPEF);
        }
    }
    return 0;
}
